package adminkindboxreqservice

import (
	"context"

	param "git.gocasts.ir/ebhomengo/niki/param/admin/kind_box_req"
	response "git.gocasts.ir/ebhomengo/niki/pkg/response_builder"
	richerror "git.gocasts.ir/ebhomengo/niki/pkg/rich_error"
)

func (s Service) Get(ctx context.Context, req param.GetKindBoxReqRequest) (param.GetKindBoxReqResponse, error) {
	const op = "adminkindboxreqservice.Get"
	if fieldErrors, vErr := s.vld.ValidateGetRequest(ctx, req); vErr != nil {
		return param.GetKindBoxReqResponse{FieldErrors: fieldErrors}, richerror.New(op).WithErr(vErr)
	}
	kindBoxReq, err := s.repo.GetByID(ctx, req.KindBoxID)
	if err != nil {
		return param.GetKindBoxReqResponse{}, richerror.New(op).WithErr(err)
	}

	return param.GetKindBoxReqResponse{
		Data: param.Data{
			ID:                 kindBoxReq.ID,
			BenefactorID:       kindBoxReq.BenefactorID,
			KindBoxType:        kindBoxReq.KindBoxType,
			CountRequested:     kindBoxReq.CountRequested,
			CountAccepted:      kindBoxReq.CountAccepted,
			Description:        kindBoxReq.Description,
			Status:             kindBoxReq.Status,
			DeliverReferTimeID: kindBoxReq.DeliverReferTimeID,
			DeliverReferDate:   kindBoxReq.DeliverReferDate,
			DeliverAddressID:   kindBoxReq.DeliverAddressID,
			SenderAgentID:      kindBoxReq.SenderAgentID,
			DeliveredAt:        response.GetNullDate(kindBoxReq.DeliveredAt),
		},
	}, nil
}
